require 'spec_helper'

describe 'RandTest::Picks' do

  shared_examples "RandTest::Picks from collections" do
    context "with a non empty collection" do

      subject(:pick) { random_from(collection) }

      it "selects an element within the collection" do
        expect(collection).to include(pick)
      end
    end

    context "with an empty collection" do
      it "raise an exception" do
        expect{ random_from(empty_collection) }.to raise_error
      end
    end
  end

  describe "#Array" do
    it_behaves_like "RandTest::Picks from collections" do
      let(:collection) { [1,2,3,4,5,6,7,8,9,0] }
      let(:empty_collection) { [] }
    end
  end

  describe "#Hash" do
    it_behaves_like "RandTest::Picks from collections" do
      let(:collection) { {:a => 1, :b => 2} }
      let(:empty_collection) { {} }
    end
  end

end
